
<!DOCTYPE html>


<html lang="en" data-content_root="../../../" >

  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="viewport" content="width=device-width, initial-scale=1" />

    <title>Graph Matching &#8212; Eclipse Aidge  documentation</title>
  
  
  
  <script data-cfasync="false">
    document.documentElement.dataset.mode = localStorage.getItem("mode") || "";
    document.documentElement.dataset.theme = localStorage.getItem("theme") || "";
  </script>
  <!--
    this give us a css class that will be invisible only if js is disabled
  -->
  <noscript>
    <style>
      .pst-js-only { display: none !important; }

    </style>
  </noscript>
  
  <!-- Loaded before other Sphinx assets -->
  <link href="../../../_static/styles/theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />
<link href="../../../_static/styles/pydata-sphinx-theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />

    <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css?v=8f2a1f02" />
    <link rel="stylesheet" type="text/css" href="../../../_static/graphviz.css?v=4ae1632d" />
    <link rel="stylesheet" type="text/css" href="../../../_static/copybutton.css?v=76b2166b" />
    <link rel="stylesheet" type="text/css" href="../../../_static/sg_gallery.css?v=d2d258e8" />
    <link rel="stylesheet" type="text/css" href="../../../_static/sphinx-design.min.css?v=95c83b7e" />
    <link rel="stylesheet" type="text/css" href="../../../_static/css/custom.css?v=794b2ffd" />
  
  <!-- So that users can add custom icons -->
  <script src="../../../_static/scripts/fontawesome.js?digest=8878045cc6db502f8baf"></script>
  <!-- Pre-loaded scripts that we'll load fully later -->
  <link rel="preload" as="script" href="../../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf" />
<link rel="preload" as="script" href="../../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf" />

    <script src="../../../_static/documentation_options.js?v=5929fcd5"></script>
    <script src="../../../_static/doctools.js?v=9bcbadda"></script>
    <script src="../../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../../_static/clipboard.min.js?v=a7894cd8"></script>
    <script src="../../../_static/copybutton.js?v=f281be69"></script>
    <script src="../../../_static/design-tabs.js?v=f930bc37"></script>
    <script src="https://cdn.jsdelivr.net/npm/@jupyter-widgets/html-manager@^1.0.1/dist/embed-amd.js"></script>
    <script>DOCUMENTATION_OPTIONS.pagename = 'source/API/Core/graphMatching';</script>
    <script>
        DOCUMENTATION_OPTIONS.theme_version = '0.16.1';
        DOCUMENTATION_OPTIONS.theme_switcher_json_url = 'https://eclipse-aidge.readthedocs.io/en/dev/_static/version_switcher.json';
        DOCUMENTATION_OPTIONS.theme_switcher_version_match = '0.5.0';
        DOCUMENTATION_OPTIONS.show_version_warning_banner =
            false;
        </script>
    <script src="../../../_static/js/mermaid.min.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
    <link rel="next" title="Recipes" href="recipes.html" />
    <link rel="prev" title="Scheduler" href="scheduler.html" />
  <meta name="viewport" content="width=device-width, initial-scale=1"/>
  <meta name="docsearch:language" content="en"/>
  <meta name="docsearch:version" content="0.5.0" />
  </head>
  
  
  <body data-bs-spy="scroll" data-bs-target=".bd-toc-nav" data-offset="180" data-bs-root-margin="0px 0px -60%" data-default-mode="">

  
  
  <div id="pst-skip-link" class="skip-link d-print-none"><a href="#main-content">Skip to main content</a></div>
  
  <div id="pst-scroll-pixel-helper"></div>
  
  <button type="button" class="btn rounded-pill" id="pst-back-to-top">
    <i class="fa-solid fa-arrow-up"></i>Back to top</button>

  
  <dialog id="pst-search-dialog">
    
<form class="bd-search d-flex align-items-center"
      action="../../../search.html"
      method="get">
  <i class="fa-solid fa-magnifying-glass"></i>
  <input type="search"
         class="form-control"
         name="q"
         placeholder="Search the docs ..."
         aria-label="Search the docs ..."
         autocomplete="off"
         autocorrect="off"
         autocapitalize="off"
         spellcheck="false"/>
  <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd>K</kbd></span>
</form>
  </dialog>

  <div class="pst-async-banner-revealer d-none">
  <aside id="bd-header-version-warning" class="d-none d-print-none" aria-label="Version warning"></aside>
</div>

  
    <header class="bd-header navbar navbar-expand-lg bd-navbar d-print-none">
<div class="bd-header__inner bd-page-width">
  <button class="pst-navbar-icon sidebar-toggle primary-toggle" aria-label="Site navigation">
    <span class="fa-solid fa-bars"></span>
  </button>
  
  
  <div class="col-lg-3 navbar-header-items__start">
    
      <div class="navbar-item">

  
    
  

<a class="navbar-brand logo" href="../../../index.html">
  
  
  
  
  
    
    
      
    
    
    <img src="../../../_static/Isotype-aidge.png" class="logo__image only-light" alt=""/>
    <img src="../../../_static/Isotype-aidge.png" class="logo__image only-dark pst-js-only" alt=""/>
  
  
    <p class="title logo__title">Eclipse Aidge</p>
  
</a></div>
    
      <div class="navbar-item">
<div class="version-switcher__container dropdown pst-js-only">
  <button id="pst-version-switcher-button-2"
    type="button"
    class="version-switcher__button btn btn-sm dropdown-toggle"
    data-bs-toggle="dropdown"
    aria-haspopup="listbox"
    aria-controls="pst-version-switcher-list-2"
    aria-label="Version switcher list"
  >
    Choose version  <!-- this text may get changed later by javascript -->
    <span class="caret"></span>
  </button>
  <div id="pst-version-switcher-list-2"
    class="version-switcher__menu dropdown-menu list-group-flush py-0"
    role="listbox" aria-labelledby="pst-version-switcher-button-2">
    <!-- dropdown will be populated by javascript on page load -->
  </div>
</div></div>
    
  </div>
  
  <div class="col-lg-9 navbar-header-items">
    
    <div class="me-auto navbar-header-items__center">
      
        <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../GetStarted/index.html">
    Get Started
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../UserGuide/index.html">
    User Guide
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../Tutorial/index.html">
    Tutorials
  </a>
</li>


<li class="nav-item current active">
  <a class="nav-link nav-internal" href="../index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
      
    </div>
    
    
    <div class="navbar-header-items__end">
      
        <div class="navbar-item navbar-persistent--container">
          

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
        </div>
      
      
        <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
      
        <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
      
    </div>
    
  </div>
  
  
    <div class="navbar-persistent--mobile">

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
    </div>
  

  
    <button class="pst-navbar-icon sidebar-toggle secondary-toggle" aria-label="On this page">
      <span class="fa-solid fa-outdent"></span>
    </button>
  
</div>

    </header>
  

  <div class="bd-container">
    <div class="bd-container__inner bd-page-width">
      
      
      
      <dialog id="pst-primary-sidebar-modal"></dialog>
      <div id="pst-primary-sidebar" class="bd-sidebar-primary bd-sidebar">
        

  
  <div class="sidebar-header-items sidebar-primary__section">
    
    
      <div class="sidebar-header-items__center">
        
          
          
            <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../GetStarted/index.html">
    Get Started
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../UserGuide/index.html">
    User Guide
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../../Tutorial/index.html">
    Tutorials
  </a>
</li>


<li class="nav-item current active">
  <a class="nav-link nav-internal" href="../index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
          
        
      </div>
    
    
    
      <div class="sidebar-header-items__end">
        
          <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
        
          <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
        
      </div>
    
  </div>
  
    <div class="sidebar-primary-items__start sidebar-primary__section">
        <div class="sidebar-primary-item">
<nav class="bd-docs-nav bd-links"
     aria-label="Section Navigation">
  <p class="bd-links__title" role="heading" aria-level="1">Section Navigation</p>
  <div class="bd-toc-item navbar-nav"><ul class="current nav bd-sidenav">
<li class="toctree-l1 current active has-children"><a class="reference internal" href="index.html">Aidge core API</a><details open="open"><summary><span class="toctree-toggle" role="presentation"><i class="fa-solid fa-chevron-down"></i></span></summary><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="data.html">Data</a></li>
<li class="toctree-l2"><a class="reference internal" href="graph.html">Graph</a></li>
<li class="toctree-l2"><a class="reference internal" href="operator.html">Operators</a></li>
<li class="toctree-l2"><a class="reference internal" href="backend.html">Backend</a></li>
<li class="toctree-l2"><a class="reference internal" href="scheduler.html">Scheduler</a></li>
<li class="toctree-l2 current active"><a class="current reference internal" href="#">Graph Matching</a></li>
<li class="toctree-l2"><a class="reference internal" href="recipes.html">Recipes</a></li>
<li class="toctree-l2"><a class="reference internal" href="export.html">Export</a></li>
</ul>
</details></li>
<li class="toctree-l1"><a class="reference internal" href="../BackendCPU/index.html">Aidge backend CPU</a></li>
<li class="toctree-l1"><a class="reference internal" href="../Onnx/index.html">Aidge ONNX API</a></li>
<li class="toctree-l1"><a class="reference internal" href="../BackendOPENCV/index.html">Aidge backend OpenCV API</a></li>
<li class="toctree-l1"><a class="reference internal" href="../ExportTensorRT/index.html">Aidge Export TensorRT API</a></li>
</ul>
</div>
</nav></div>
    </div>
  
  
  <div class="sidebar-primary-items__end sidebar-primary__section">
      <div class="sidebar-primary-item">
<div id="ethical-ad-placement"
      class="flat"
      data-ea-publisher="readthedocs"
      data-ea-type="readthedocs-sidebar"
      data-ea-manual="true">
</div></div>
  </div>


      </div>
      
      <main id="main-content" class="bd-main" role="main">
        
        
          <div class="bd-content">
            <div class="bd-article-container">
              
              <div class="bd-header-article d-print-none">
<div class="header-article-items header-article__inner">
  
    <div class="header-article-items__start">
      
        <div class="header-article-item">

<nav aria-label="Breadcrumb" class="d-print-none">
  <ul class="bd-breadcrumbs">
    
    <li class="breadcrumb-item breadcrumb-home">
      <a href="../../../index.html" class="nav-link" aria-label="Home">
        <i class="fa-solid fa-home"></i>
      </a>
    </li>
    
    <li class="breadcrumb-item"><a href="../index.html" class="nav-link">API</a></li>
    
    
    <li class="breadcrumb-item"><a href="index.html" class="nav-link">Aidge core API</a></li>
    
    <li class="breadcrumb-item active" aria-current="page"><span class="ellipsis">Graph Matching</span></li>
  </ul>
</nav>
</div>
      
    </div>
  
  
</div>
</div>
              
              
              
                
<div id="searchbox"></div>
                <article class="bd-article">
                  
  <section id="graph-matching">
<h1>Graph Matching<a class="headerlink" href="#graph-matching" title="Link to this heading">#</a></h1>
<p>Aidge introduces a simple and efficient DSL for graph matching, sometimes called “graph regex”. It is possible to write complex textual queries to find a quantified or unquantified set of nodes with specific types, attributes and/or relationships between them. This is particularly useful to implement sophisticated pattern-matching heuristics with no effort!</p>
<p>Here is an example of a query that you can do in Aidge:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">matches</span> <span class="o">=</span> <span class="n">aidge_core</span><span class="o">.</span><span class="n">SinglePassGraphMatching</span><span class="p">(</span><span class="n">model</span><span class="p">)</span><span class="o">.</span><span class="n">match</span><span class="p">(</span><span class="s2">&quot;(Pad#?-&gt;Conv#|Deconv#-&gt;Pad#?)-&gt;ReLU#?-&gt;Add#1?-&gt;ReLU#?-&gt;MaxPool#?-&gt;ReLU#?;.-&gt;Add#1?&quot;</span><span class="p">)</span>

<span class="k">for</span> <span class="n">match</span> <span class="ow">in</span> <span class="n">matches</span><span class="p">:</span>
    <span class="n">aidge_core</span><span class="o">.</span><span class="n">GraphView</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="n">match</span><span class="p">,</span> <span class="n">MyCustomIPOperator</span><span class="p">())</span>
</pre></div>
</div>
<p>You can define your own node test function as well:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">gm</span> <span class="o">=</span> <span class="n">aidge_core</span><span class="o">.</span><span class="n">SinglePassGraphMatching</span><span class="p">(</span><span class="n">model</span><span class="p">)</span>
<span class="n">gm</span><span class="o">.</span><span class="n">add_node_lambda</span><span class="p">(</span><span class="s2">&quot;test&quot;</span><span class="p">,</span> <span class="k">lambda</span> <span class="n">node</span><span class="p">:</span> <span class="o">...</span><span class="p">)</span>

<span class="n">matches</span> <span class="o">=</span> <span class="n">gm</span><span class="o">.</span><span class="n">match</span><span class="p">(</span><span class="s2">&quot;Conv-&gt;test&quot;</span><span class="p">)</span>
</pre></div>
</div>
<div class="sd-tab-set docutils">
<input checked="checked" id="sd-tab-item-0" name="sd-tab-set-0" type="radio">
<label class="sd-tab-label" for="sd-tab-item-0">
Python</label><div class="sd-tab-content docutils">
<dl class="py class">
<dt class="sig sig-object py" id="aidge_core.SinglePassGraphMatching">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">aidge_core.</span></span><span class="sig-name descname"><span class="pre">SinglePassGraphMatching</span></span><a class="headerlink" href="#aidge_core.SinglePassGraphMatching" title="Link to this definition">#</a></dt>
<dd><dl class="py method">
<dt class="sig sig-object py" id="aidge_core.SinglePassGraphMatching.__init__">
<span class="sig-name descname"><span class="pre">__init__</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="#aidge_core.SinglePassGraphMatching" title="aidge_core.aidge_core.SinglePassGraphMatching"><span class="pre">aidge_core.aidge_core.SinglePassGraphMatching</span></a></span></em>, <em class="sig-param"><span class="n"><span class="pre">graph</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="graph.html#aidge_core.GraphView" title="aidge_core.aidge_core.GraphView"><span class="pre">aidge_core.aidge_core.GraphView</span></a></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="headerlink" href="#aidge_core.SinglePassGraphMatching.__init__" title="Link to this definition">#</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.SinglePassGraphMatching.add_node_lambda">
<span class="sig-name descname"><span class="pre">add_node_lambda</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="#aidge_core.SinglePassGraphMatching" title="aidge_core.aidge_core.SinglePassGraphMatching"><span class="pre">aidge_core.aidge_core.SinglePassGraphMatching</span></a></span></em>, <em class="sig-param"><span class="n"><span class="pre">name</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">func</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Callable</span><span class="p"><span class="pre">[</span></span><span class="p"><span class="pre">[</span></span><a class="reference internal" href="graph.html#aidge_core.Node" title="aidge_core.aidge_core.Node"><span class="pre">aidge_core.aidge_core.Node</span></a><span class="p"><span class="pre">]</span></span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">bool</span><span class="p"><span class="pre">]</span></span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="headerlink" href="#aidge_core.SinglePassGraphMatching.add_node_lambda" title="Link to this definition">#</a></dt>
<dd></dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="aidge_core.SinglePassGraphMatching.match">
<span class="sig-name descname"><span class="pre">match</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">self</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="#aidge_core.SinglePassGraphMatching" title="aidge_core.aidge_core.SinglePassGraphMatching"><span class="pre">aidge_core.aidge_core.SinglePassGraphMatching</span></a></span></em>, <em class="sig-param"><span class="n"><span class="pre">query</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">disjoint</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">bool</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">List</span><span class="p"><span class="pre">[</span></span><span class="pre">aidge_core.aidge_core.MatchingResult</span><span class="p"><span class="pre">]</span></span></span></span><a class="headerlink" href="#aidge_core.SinglePassGraphMatching.match" title="Link to this definition">#</a></dt>
<dd><dl class="simple">
<dt>Matches a query by direct, single-pass parse and match.</dt><dd><dl class="field-list simple">
<dt class="field-odd">param query<span class="colon">:</span></dt>
<dd class="field-odd"><p>The query string to search.</p>
</dd>
<dt class="field-even">param disjoint<span class="colon">:</span></dt>
<dd class="field-even"><p>If true, only keep the longest disjoint matches.</p>
</dd>
<dt class="field-odd">return<span class="colon">:</span></dt>
<dd class="field-odd"><p>A set of MatchingResult instances.</p>
</dd>
</dl>
</dd>
</dl>
</dd></dl>

</dd></dl>

</div>
<input id="sd-tab-item-1" name="sd-tab-set-0" type="radio">
<label class="sd-tab-label" for="sd-tab-item-1">
C++</label><div class="sd-tab-content docutils">
<dl class="cpp class">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatchingE">
<span class="target" id="classAidge_1_1SinglePassGraphMatching"></span><span class="k"><span class="pre">class</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">SinglePassGraphMatching</span></span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatchingE" title="Link to this definition">#</a><br /></dt>
<dd><p>A simple experimental graph matching class which works by direct, single pass parse and match, without constructing any intermediate representation. Due to its single pass nature, it has some constrains on how the queries must be formulated. </p>
<div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric" id="breathe-section-title-public-functions">Public Functions</p>
<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching23SinglePassGraphMatchingEv">
<span class="target" id="classAidge_1_1SinglePassGraphMatching_1aedd178225bb048a234cb682c2f64b5ea"></span><span class="sig-name descname"><span class="n"><span class="pre">SinglePassGraphMatching</span></span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="k"><span class="pre">delete</span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching23SinglePassGraphMatchingEv" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching23SinglePassGraphMatchingENSt10shared_ptrI9GraphViewEE">
<span class="target" id="classAidge_1_1SinglePassGraphMatching_1a3642ac6e7495aa7da6abd683caf5a720"></span><span class="k"><span class="pre">inline</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">SinglePassGraphMatching</span></span></span><span class="sig-paren">(</span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">shared_ptr</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="graph.html#_CPPv4N5Aidge9GraphViewE" title="Aidge::GraphView"><span class="n"><span class="pre">GraphView</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="n sig-param"><span class="pre">graph</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching23SinglePassGraphMatchingENSt10shared_ptrI9GraphViewEE" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching23SinglePassGraphMatchingERK23SinglePassGraphMatching">
<span class="target" id="classAidge_1_1SinglePassGraphMatching_1ac64a125142909c8f716a5842482dc719"></span><span class="sig-name descname"><span class="n"><span class="pre">SinglePassGraphMatching</span></span></span><span class="sig-paren">(</span><span class="k"><span class="pre">const</span></span><span class="w"> </span><a class="reference internal" href="#_CPPv4N5Aidge23SinglePassGraphMatching23SinglePassGraphMatchingERK23SinglePassGraphMatching" title="Aidge::SinglePassGraphMatching::SinglePassGraphMatching"><span class="n"><span class="pre">SinglePassGraphMatching</span></span></a><span class="w"> </span><span class="p"><span class="pre">&amp;</span></span><span class="n sig-param"><span class="pre">other</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching23SinglePassGraphMatchingERK23SinglePassGraphMatching" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatchingD0Ev">
<span class="target" id="classAidge_1_1SinglePassGraphMatching_1a2609d7372062c13d0f041ad695609a44"></span><span class="sig-name descname"><span class="n"><span class="pre">~SinglePassGraphMatching</span></span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><span class="w"> </span><span class="k"><span class="pre">noexcept</span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatchingD0Ev" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatchingaSERK23SinglePassGraphMatching">
<span class="target" id="classAidge_1_1SinglePassGraphMatching_1a4f9071f5f3fa1db0902cada7000d4969"></span><a class="reference internal" href="#_CPPv4N5Aidge23SinglePassGraphMatchingE" title="Aidge::SinglePassGraphMatching"><span class="n"><span class="pre">SinglePassGraphMatching</span></span></a><span class="w"> </span><span class="p"><span class="pre">&amp;</span></span><span class="sig-name descname"><span class="k"><span class="pre">operator</span></span><span class="o"><span class="pre">=</span></span></span><span class="sig-paren">(</span><span class="k"><span class="pre">const</span></span><span class="w"> </span><a class="reference internal" href="#_CPPv4N5Aidge23SinglePassGraphMatchingE" title="Aidge::SinglePassGraphMatching"><span class="n"><span class="pre">SinglePassGraphMatching</span></span></a><span class="w"> </span><span class="p"><span class="pre">&amp;</span></span><span class="n sig-param"><span class="pre">other</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatchingaSERK23SinglePassGraphMatching" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching5matchERKNSt6stringEb">
<span class="target" id="classAidge_1_1SinglePassGraphMatching_1a6ddbe78a411df934140d02008f68cf62"></span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">set</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResultE" title="Aidge::SinglePassGraphMatching::MatchingResult"><span class="n"><span class="pre">MatchingResult</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">match</span></span></span><span class="sig-paren">(</span><span class="k"><span class="pre">const</span></span><span class="w"> </span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">string</span></span><span class="w"> </span><span class="p"><span class="pre">&amp;</span></span><span class="n sig-param"><span class="pre">query</span></span>, <span class="kt"><span class="pre">bool</span></span><span class="w"> </span><span class="n sig-param"><span class="pre">disjoint</span></span><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="k"><span class="pre">false</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching5matchERKNSt6stringEb" title="Link to this definition">#</a><br /></dt>
<dd><p>Matches a query by direct, single pass parse and match. The returned matches are non-ordered and therefore stored in a std::set.</p>
<p>Some rules:<ul class="simple">
<li><p>The first node of the first sequence is the root node and cannot be optional WRONG: Conv?-&gt;ReLU (will throw an error) GOOD: ReLU&lt;-Conv?</p></li>
<li><p>The first node of any further sequence must be an existing anchor (the anchor cannot be in the middle of the sequence) WRONG: Conv-&gt;ReLU;Pad-&gt;Conv (will throw an error) Pad-&gt;Conv;Conv-&gt;ReLU (will throw an error) GOOD: Conv#-&gt;ReLU;Conv#&lt;-Pad Pad-&gt;Conv#;Conv#-&gt;ReLU</p></li>
<li><p>Any node already matched cannot be matched again (except for anchors)</p></li>
<li><p>By default, an edge matches the first output to the first input. EXAMPLE: ReLU-&gt;Conv is equivalent to ReLU-0-0&gt;Conv To match the second input, use ReLU-0-1&gt;Conv (or ReLU-1&gt;Conv) To match the second output, use ReLU-1-0&gt;Conv To match any input and/or any output, use *, like ReLU-1-*&gt;Conv or ReLU-*-0&gt;Conv or ReLU-*-*&gt;Conv The same is true for the “&lt;-” edge syntax.</p></li>
<li><p>When several nodes could match for a given node query, the first one not already in the matching result is matched, following the childs/parents ordered node list EXAMPLE: Producer in “Conv&lt;*-Producer” will match the weights Producer first EXAMPLE: Producer in “Conv#&lt;1-.;Conv#&lt;*-Producer” will match the bias Producer because the weights Producer has already been matched</p></li>
<li><p>One always matches a sub-graph: additional connections can exist anywhere in the matched sub-graph EXAMPLE: “Add&lt;*-.” will match the Add operator and its first input, any additional inputs will not be included in the result EXAMPLE: “(Add#&lt;*-.)+” will match the Add operator and all of its inputs Note that the anchor is required since we intend to match several inputs of the same node!</p></li>
<li><p>In Aidge, a node output can be connected to multiple other nodes. In your query, you can allow it or not, with the “~” or “-” modifier. EXAMPLE: “Conv-&gt;ReLU” will match the Conv that are <strong>only</strong> connected to a ReLU node at their output #0. “Conv~&gt;ReLU” will match all the Conv connected to a ReLU even if they are also connected to other nodes at the same output #0. When implementing a match &amp; replace recipe, beware that you don’t break branches in the middle of your matching result if you use “~”!</p></li>
<li><p>The matching results can be overlapping, meaning that some nodes may be found in multiple results. Some results may be subsets of other results. EXAMPLE: assume graph Conv#1-&gt;ReLU#1-&gt;Conv#2-&gt;ReLU#2 “Conv-&gt;ReLU?-&gt;Conv?-&gt;ReLU?” will return both Conv#1-&gt;ReLU#1-&gt;Conv#2-&gt;ReLU#2 and Conv#2-&gt;ReLU#2 To avoid this behavior, set the disjoint argument to true. In this case, only Conv#1-&gt;ReLU#1-&gt;Conv#2-&gt;ReLU#2 will be kept in the example above.</p></li>
<li><p>Whitespaces are allowed anywhere in the query</p></li>
</ul>
</p>
<p>QUERY = SEQ | NODE_OR_BLOCK (‘;’ (SEQ | NODE_OR_BLOCK))*</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>query</strong> – The query to search. </p></li>
<li><p><strong>disjoint</strong> – If true, only keep the longest disjoint (non-overlapping) matches. </p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>std::set&lt;MatchingResult&gt; Set of matches, each stored in a <a class="reference internal" href="#structAidge_1_1SinglePassGraphMatching_1_1MatchingResult"><span class="std std-ref">MatchingResult</span></a> struct. </p>
</dd>
</dl>
</dd></dl>

<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching9matchFromENSt10shared_ptrI4NodeEERKNSt6stringE">
<span class="target" id="classAidge_1_1SinglePassGraphMatching_1a8080c172fe851da6e659a6f813eeff99"></span><a class="reference internal" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResultE" title="Aidge::SinglePassGraphMatching::MatchingResult"><span class="n"><span class="pre">MatchingResult</span></span></a><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">matchFrom</span></span></span><span class="sig-paren">(</span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">shared_ptr</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="graph.html#_CPPv4N5Aidge4NodeE" title="Aidge::Node"><span class="n"><span class="pre">Node</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="n sig-param"><span class="pre">startNode</span></span>, <span class="k"><span class="pre">const</span></span><span class="w"> </span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">string</span></span><span class="w"> </span><span class="p"><span class="pre">&amp;</span></span><span class="n sig-param"><span class="pre">query</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching9matchFromENSt10shared_ptrI4NodeEERKNSt6stringE" title="Link to this definition">#</a><br /></dt>
<dd><p>Same as <a class="reference internal" href="#classAidge_1_1SinglePassGraphMatching_1a6ddbe78a411df934140d02008f68cf62"><span class="std std-ref">match()</span></a> but with a mandatory start node. </p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>startNode</strong> – Mandatory start node for the query. </p></li>
<li><p><strong>query</strong> – The query to search. </p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p><a class="reference internal" href="#structAidge_1_1SinglePassGraphMatching_1_1MatchingResult"><span class="std std-ref">MatchingResult</span></a> <a class="reference internal" href="#structAidge_1_1SinglePassGraphMatching_1_1MatchingResult"><span class="std std-ref">MatchingResult</span></a> struct, with empty graph if query is not found, or the graph corresponding to the query. </p>
</dd>
</dl>
</dd></dl>

<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching22filterLonguestDisjointERKNSt3setI14MatchingResultEE">
<span class="target" id="classAidge_1_1SinglePassGraphMatching_1af9dfc277ec498e4a4b80ed021e75519b"></span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">set</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResultE" title="Aidge::SinglePassGraphMatching::MatchingResult"><span class="n"><span class="pre">MatchingResult</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">filterLonguestDisjoint</span></span></span><span class="sig-paren">(</span><span class="k"><span class="pre">const</span></span><span class="w"> </span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">set</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResultE" title="Aidge::SinglePassGraphMatching::MatchingResult"><span class="n"><span class="pre">MatchingResult</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="p"><span class="pre">&amp;</span></span><span class="n sig-param"><span class="pre">matches</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching22filterLonguestDisjointERKNSt3setI14MatchingResultEE" title="Link to this definition">#</a><br /></dt>
<dd><p>Filter to keep only the longest disjoint (non-overlapping) matches. </p>
</dd></dl>

<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching13addNodeLambdaERKNSt6stringENSt8functionIFbRKNSt10shared_ptrI4NodeEEEEE">
<span class="target" id="classAidge_1_1SinglePassGraphMatching_1a6d5442994833d9c10696fd4044afaf9f"></span><span class="k"><span class="pre">inline</span></span><span class="w"> </span><span class="kt"><span class="pre">void</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">addNodeLambda</span></span></span><span class="sig-paren">(</span><span class="k"><span class="pre">const</span></span><span class="w"> </span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">string</span></span><span class="w"> </span><span class="p"><span class="pre">&amp;</span></span><span class="n sig-param"><span class="pre">name</span></span>, <span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">function</span></span><span class="p"><span class="pre">&lt;</span></span><span class="kt"><span class="pre">bool</span></span><span class="p"><span class="pre">(</span></span><span class="k"><span class="pre">const</span></span><span class="w"> </span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">shared_ptr</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="graph.html#_CPPv4N5Aidge4NodeE" title="Aidge::Node"><span class="n"><span class="pre">Node</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="p"><span class="pre">&amp;</span></span><span class="p"><span class="pre">)</span></span><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="n sig-param"><span class="pre">func</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching13addNodeLambdaERKNSt6stringENSt8functionIFbRKNSt10shared_ptrI4NodeEEEEE" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

</div>
<dl class="cpp struct">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching7ContextE">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1Context"></span><span class="k"><span class="pre">struct</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">Context</span></span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching7ContextE" title="Link to this definition">#</a><br /></dt>
<dd><div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric" id="breathe-section-title-public-functions">Public Functions</p>
<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching7Context7ContextEv">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1Context_1ac69b84da4c03913e52bd9542993335ef"></span><span class="sig-name descname"><span class="n"><span class="pre">Context</span></span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context7ContextEv" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching7Context7ContextERK7Context">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1Context_1a2db6c895fbc12f3e74e1ede038bb0905"></span><span class="sig-name descname"><span class="n"><span class="pre">Context</span></span></span><span class="sig-paren">(</span><span class="k"><span class="pre">const</span></span><span class="w"> </span><a class="reference internal" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context7ContextERK7Context" title="Aidge::SinglePassGraphMatching::Context::Context"><span class="n"><span class="pre">Context</span></span></a><span class="p"><span class="pre">&amp;</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context7ContextERK7Context" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching7ContextaSERK7Context">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1Context_1a04447734033503e0f7af76cb35c213ad"></span><a class="reference internal" href="#_CPPv4N5Aidge23SinglePassGraphMatching7ContextE" title="Aidge::SinglePassGraphMatching::Context"><span class="n"><span class="pre">Context</span></span></a><span class="w"> </span><span class="p"><span class="pre">&amp;</span></span><span class="sig-name descname"><span class="k"><span class="pre">operator</span></span><span class="o"><span class="pre">=</span></span></span><span class="sig-paren">(</span><span class="k"><span class="pre">const</span></span><span class="w"> </span><a class="reference internal" href="#_CPPv4N5Aidge23SinglePassGraphMatching7ContextE" title="Aidge::SinglePassGraphMatching::Context"><span class="n"><span class="pre">Context</span></span></a><span class="p"><span class="pre">&amp;</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching7ContextaSERK7Context" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching7ContextD0Ev">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1Context_1ad04d352aed56be4ddecf33dfccbd5d65"></span><span class="sig-name descname"><span class="n"><span class="pre">~Context</span></span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><span class="w"> </span><span class="k"><span class="pre">noexcept</span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching7ContextD0Ev" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

</div>
<div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric" id="breathe-section-title-public-members">Public Members</p>
<dl class="cpp var">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching7Context5queryE">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1Context_1ab3f0ad73cc58f40d7096304ca038435b"></span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">string</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">query</span></span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context5queryE" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp var">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching7Context13firstSequenceE">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1Context_1aab337c0948db67307cdf94047cb2df72"></span><span class="kt"><span class="pre">bool</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">firstSequence</span></span></span><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="k"><span class="pre">true</span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context13firstSequenceE" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp var">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching7Context9firstNodeE">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1Context_1ac289276790b3cd16f9d3496dd64195c7"></span><span class="kt"><span class="pre">bool</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">firstNode</span></span></span><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="k"><span class="pre">true</span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context9firstNodeE" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp var">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching7Context10inSequenceE">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1Context_1a5188eed0e68cc7541ec726026e56dcf4"></span><span class="kt"><span class="pre">bool</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">inSequence</span></span></span><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="k"><span class="pre">false</span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context10inSequenceE" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp var">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching7Context12lookForChildE">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1Context_1ad50cb44d0d6ffb5314b7f1aee58d2705"></span><span class="kt"><span class="pre">bool</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">lookForChild</span></span></span><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="k"><span class="pre">true</span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context12lookForChildE" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp var">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching7Context12singleOutputE">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1Context_1aef5389af0f8bc1a50d1541c179f29c01"></span><span class="kt"><span class="pre">bool</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">singleOutput</span></span></span><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="k"><span class="pre">true</span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context12singleOutputE" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp var">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching7Context11edgeLeftIdxE">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1Context_1a478d53298dd06a783e7775dec68e1ef2"></span><span class="n"><span class="pre">IOIndex_t</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">edgeLeftIdx</span></span></span><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="m"><span class="pre">0</span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context11edgeLeftIdxE" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp var">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching7Context12edgeRightIdxE">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1Context_1a598326799a9f389c472d421bf34f1e74"></span><span class="n"><span class="pre">IOIndex_t</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">edgeRightIdx</span></span></span><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="m"><span class="pre">0</span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context12edgeRightIdxE" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp var">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching7Context9startNodeE">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1Context_1a773427db524bfda9b4f7f85bab13b472"></span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">shared_ptr</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="graph.html#_CPPv4N5Aidge4NodeE" title="Aidge::Node"><span class="n"><span class="pre">Node</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">startNode</span></span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context9startNodeE" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp var">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching7Context5depthE">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1Context_1a8fc7d6c9e3871c9bf2edf743504e912b"></span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">size_t</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">depth</span></span></span><span class="w"> </span><span class="p"><span class="pre">=</span></span><span class="w"> </span><span class="m"><span class="pre">0</span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context5depthE" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp var">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching7Context7anchorsE">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1Context_1a3c3255c972c1f214f74961647cf980bb"></span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">set</span></span><span class="p"><span class="pre">&lt;</span></span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">string</span></span><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">anchors</span></span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context7anchorsE" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

</div>
</dd></dl>

<dl class="cpp struct">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResultE">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1MatchingResult"></span><span class="k"><span class="pre">struct</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">MatchingResult</span></span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResultE" title="Link to this definition">#</a><br /></dt>
<dd><div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric" id="breathe-section-title-public-functions">Public Functions</p>
<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResult14MatchingResultEv">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1MatchingResult_1a0769f83721c89f8397911c113d305c6d"></span><span class="sig-name descname"><span class="n"><span class="pre">MatchingResult</span></span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResult14MatchingResultEv" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResult14MatchingResultERK14MatchingResult">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1MatchingResult_1a9b4899f2325c1442c8511c24ec43bdf4"></span><span class="sig-name descname"><span class="n"><span class="pre">MatchingResult</span></span></span><span class="sig-paren">(</span><span class="k"><span class="pre">const</span></span><span class="w"> </span><a class="reference internal" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResult14MatchingResultERK14MatchingResult" title="Aidge::SinglePassGraphMatching::MatchingResult::MatchingResult"><span class="n"><span class="pre">MatchingResult</span></span></a><span class="w"> </span><span class="p"><span class="pre">&amp;</span></span><span class="n sig-param"><span class="pre">other</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResult14MatchingResultERK14MatchingResult" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResultaSERK14MatchingResult">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1MatchingResult_1a23f6d184943f2a1ad9edb2f2fa13d2a9"></span><a class="reference internal" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResultE" title="Aidge::SinglePassGraphMatching::MatchingResult"><span class="n"><span class="pre">MatchingResult</span></span></a><span class="w"> </span><span class="p"><span class="pre">&amp;</span></span><span class="sig-name descname"><span class="k"><span class="pre">operator</span></span><span class="o"><span class="pre">=</span></span></span><span class="sig-paren">(</span><span class="k"><span class="pre">const</span></span><span class="w"> </span><a class="reference internal" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResultE" title="Aidge::SinglePassGraphMatching::MatchingResult"><span class="n"><span class="pre">MatchingResult</span></span></a><span class="w"> </span><span class="p"><span class="pre">&amp;</span></span><span class="n sig-param"><span class="pre">other</span></span><span class="sig-paren">)</span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResultaSERK14MatchingResult" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp function">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResultD0Ev">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1MatchingResult_1a1cdc2926c65caae401df0ad194db2412"></span><span class="sig-name descname"><span class="n"><span class="pre">~MatchingResult</span></span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><span class="w"> </span><span class="k"><span class="pre">noexcept</span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResultD0Ev" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

</div>
<div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric" id="breathe-section-title-public-members">Public Members</p>
<dl class="cpp var">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResult5graphE">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1MatchingResult_1a8047aba889ea4fd9da84f38f47cb0006"></span><span class="k"><span class="pre">mutable</span></span><span class="w"> </span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">shared_ptr</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="graph.html#_CPPv4N5Aidge9GraphViewE" title="Aidge::GraphView"><span class="n"><span class="pre">GraphView</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">graph</span></span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResult5graphE" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp var">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResult7anchorsE">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1MatchingResult_1a71641f17eeb0893764f1869064c190ac"></span><span class="k"><span class="pre">mutable</span></span><span class="w"> </span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">map</span></span><span class="p"><span class="pre">&lt;</span></span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">string</span></span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">map</span></span><span class="p"><span class="pre">&lt;</span></span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">string</span></span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">shared_ptr</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="graph.html#_CPPv4N5Aidge4NodeE" title="Aidge::Node"><span class="n"><span class="pre">Node</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="p"><span class="pre">&gt;</span></span><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">anchors</span></span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResult7anchorsE" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

<dl class="cpp var">
<dt class="sig sig-object cpp" id="_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResult9startNodeE">
<span class="target" id="structAidge_1_1SinglePassGraphMatching_1_1MatchingResult_1a1989fa5253023177a20d964a6a18f606"></span><span class="k"><span class="pre">mutable</span></span><span class="w"> </span><span class="n"><span class="pre">std</span></span><span class="p"><span class="pre">::</span></span><span class="n"><span class="pre">shared_ptr</span></span><span class="p"><span class="pre">&lt;</span></span><a class="reference internal" href="graph.html#_CPPv4N5Aidge4NodeE" title="Aidge::Node"><span class="n"><span class="pre">Node</span></span></a><span class="p"><span class="pre">&gt;</span></span><span class="w"> </span><span class="sig-name descname"><span class="n"><span class="pre">startNode</span></span></span><a class="headerlink" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResult9startNodeE" title="Link to this definition">#</a><br /></dt>
<dd></dd></dl>

</div>
</dd></dl>

</dd></dl>

</div>
</div>
</section>


                </article>
              
              
              
              
              
                <footer class="prev-next-footer d-print-none">
                  
<div class="prev-next-area">
    <a class="left-prev"
       href="scheduler.html"
       title="previous page">
      <i class="fa-solid fa-angle-left"></i>
      <div class="prev-next-info">
        <p class="prev-next-subtitle">previous</p>
        <p class="prev-next-title">Scheduler</p>
      </div>
    </a>
    <a class="right-next"
       href="recipes.html"
       title="next page">
      <div class="prev-next-info">
        <p class="prev-next-subtitle">next</p>
        <p class="prev-next-title">Recipes</p>
      </div>
      <i class="fa-solid fa-angle-right"></i>
    </a>
</div>
                </footer>
              
            </div>
            
            
              
                <dialog id="pst-secondary-sidebar-modal"></dialog>
                <div id="pst-secondary-sidebar" class="bd-sidebar-secondary bd-toc"><div class="sidebar-secondary-items sidebar-secondary__inner">


  <div class="sidebar-secondary-item">
<div
    id="pst-page-navigation-heading-2"
    class="page-toc tocsection onthispage">
    <i class="fa-solid fa-list"></i> On this page
  </div>
  <nav class="bd-toc-nav page-toc" aria-labelledby="pst-page-navigation-heading-2">
    <ul class="visible nav section-nav flex-column">
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.SinglePassGraphMatching"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching</span></code></a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.SinglePassGraphMatching.__init__"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching.__init__()</span></code></a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.SinglePassGraphMatching.add_node_lambda"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching.add_node_lambda()</span></code></a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#aidge_core.SinglePassGraphMatching.match"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching.match()</span></code></a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatchingE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching</span></code></a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching23SinglePassGraphMatchingEv"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::SinglePassGraphMatching()</span></code></a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching23SinglePassGraphMatchingENSt10shared_ptrI9GraphViewEE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::SinglePassGraphMatching()</span></code></a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching23SinglePassGraphMatchingERK23SinglePassGraphMatching"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::SinglePassGraphMatching()</span></code></a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatchingD0Ev"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::~SinglePassGraphMatching()</span></code></a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatchingaSERK23SinglePassGraphMatching"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::operator=()</span></code></a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching5matchERKNSt6stringEb"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::match()</span></code></a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching9matchFromENSt10shared_ptrI4NodeEERKNSt6stringE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::matchFrom()</span></code></a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching22filterLonguestDisjointERKNSt3setI14MatchingResultEE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::filterLonguestDisjoint()</span></code></a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching13addNodeLambdaERKNSt6stringENSt8functionIFbRKNSt10shared_ptrI4NodeEEEEE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::addNodeLambda()</span></code></a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching7ContextE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::Context</span></code></a><ul class="visible nav section-nav flex-column">
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context7ContextEv"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::Context::Context()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context7ContextERK7Context"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::Context::Context()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching7ContextaSERK7Context"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::Context::operator=()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching7ContextD0Ev"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::Context::~Context()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context5queryE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::Context::query</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context13firstSequenceE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::Context::firstSequence</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context9firstNodeE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::Context::firstNode</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context10inSequenceE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::Context::inSequence</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context12lookForChildE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::Context::lookForChild</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context12singleOutputE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::Context::singleOutput</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context11edgeLeftIdxE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::Context::edgeLeftIdx</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context12edgeRightIdxE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::Context::edgeRightIdx</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context9startNodeE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::Context::startNode</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context5depthE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::Context::depth</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching7Context7anchorsE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::Context::anchors</span></code></a></li>
</ul>
</li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResultE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::MatchingResult</span></code></a><ul class="visible nav section-nav flex-column">
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResult14MatchingResultEv"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::MatchingResult::MatchingResult()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResult14MatchingResultERK14MatchingResult"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::MatchingResult::MatchingResult()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResultaSERK14MatchingResult"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::MatchingResult::operator=()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResultD0Ev"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::MatchingResult::~MatchingResult()</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResult5graphE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::MatchingResult::graph</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResult7anchorsE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::MatchingResult::anchors</span></code></a></li>
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#_CPPv4N5Aidge23SinglePassGraphMatching14MatchingResult9startNodeE"><code class="docutils literal notranslate"><span class="pre">SinglePassGraphMatching::MatchingResult::startNode</span></code></a></li>
</ul>
</li>
</ul>
</li>
</ul>
  </nav></div>

  <div class="sidebar-secondary-item">

  
  <div class="tocsection editthispage">
    <a href="https://gitlab.eclipse.org/eclipse/aidge/aidge/-/edit/master/docs/source/API/Core/graphMatching.rst">
      <i class="fa-solid fa-pencil"></i>
      
      
        
          Edit on GitLab
        
      
    </a>
  </div>
</div>

  <div class="sidebar-secondary-item">
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../../../_sources/source/API/Core/graphMatching.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div></div>

</div></div>
              
            
          </div>
          <footer class="bd-footer-content">
            
          </footer>
        
      </main>
    </div>
  </div>
  
  <!-- Scripts loaded after <body> so the DOM is not blocked -->
  <script defer src="../../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf"></script>
<script defer src="../../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf"></script>

  <footer class="bd-footer">
<div class="bd-footer__inner bd-page-width">
  
    <div class="footer-items__start">
      
        <div class="footer-item">

  <p class="copyright">
    
      © Copyright 2023, CEA LIST.
      <br/>
    
  </p>
</div>
      
        <div class="footer-item">

  <p class="sphinx-version">
    Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 8.1.3.
    <br/>
  </p>
</div>
      
    </div>
  
  
  
    <div class="footer-items__end">
      
        <div class="footer-item">
<p class="theme-version">
  <!-- # L10n: Setting the PST URL as an argument as this does not need to be localized -->
  Built with the <a href="https://pydata-sphinx-theme.readthedocs.io/en/stable/index.html">PyData Sphinx Theme</a> 0.16.1.
</p></div>
      
    </div>
  
</div>

  </footer>
  </body>
</html>